package com.yzdx.AiInterviewer.controller.VxController;

import com.yzdx.AiInterviewer.comment.R;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxInterviewRecordDto;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxNoticeDto;
import com.yzdx.AiInterviewer.service.InterviewNoticeService;
import com.yzdx.AiInterviewer.service.VxService.VxCarouselChartService;
import com.yzdx.AiInterviewer.service.VxService.VxInterviewApplicationService;
import com.yzdx.AiInterviewer.service.VxService.VxInterviewRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/vx_interview")
public class VxInterviewController {

    @Autowired
    private VxCarouselChartService vxCarouselChartService;
    @Autowired
    private VxInterviewApplicationService vxInterviewApplicationService;
    @Autowired
    private InterviewNoticeService interviewNoticeService;
    @Autowired
    private VxInterviewRecordService vxInterviewRecordService;

    @GetMapping("/getCarouselChart")
    public R getCarouselChart(){
        return R.success(vxCarouselChartService.getVxCarouselChartService());
    }
    @PostMapping("/updateCarouselChart")
    public R updateCarouselChart(@RequestBody Map<String,Object> updateInfo){
        String images=(String) updateInfo.get("submitImages");

        Integer integer = vxCarouselChartService.updateCarouselChartService(images);

        if(integer!=1){
            return R.error("更新轮播图失败");
        }
        return R.success("更新轮播图成功");


    }

    @PostMapping("addInterviewApplication")
    public R addInterviewApplication( @RequestParam(value = "jobId")Integer jobId,
                                      @RequestParam(value = "userId")Integer userId,
                                      @RequestParam(value = "postingId")Integer postingId,
                                      @RequestParam(value = "companyEncoding")String companyEncoding
                                    ){
        Integer rows=vxInterviewApplicationService.addInterviewApplication(jobId,userId,postingId,companyEncoding);
        if(rows==-2){
            return R.error("申请失败");
        }
        return R.success("申请成功");
    }
    @GetMapping("/getInterviewNotice")
    public R getInterviewNotice(Integer userId){

        List<VxNoticeDto> VxNoticeDtoList = interviewNoticeService.getInterviewNoticeByUserId(userId);

        return R.success(VxNoticeDtoList);

    }
    @GetMapping("getInterviewRecord")
    public  R getInterviewRecordList(Integer userId){
        List<VxInterviewRecordDto> list=vxInterviewRecordService.getInterviewRecordList(userId);
        return R.success(list);
    }
    @GetMapping("/searchInterviewRecord")
    public R searchInterviewRecordList(String searchCompany,Integer userId){
        List<VxInterviewRecordDto> list=vxInterviewRecordService.searchInterviewRecordList(searchCompany,userId);
        return R.success(list);
    }
    @PostMapping("/addInterviewRecord")
    public R addInterviewRecord(@RequestBody Map<String,Object> addInfo){

        String encoding=(String)addInfo.get("encoding");

        String comments=(String) addInfo.get("comments");

        Integer interviewer=(Integer) addInfo.get("interviewer");

        Integer noticeId=(Integer) addInfo.get("noticeId");

        Integer talentId=(Integer) addInfo.get("talentId") ;

        String detail=(String) addInfo.get("detail");



        Integer rows=vxInterviewRecordService.addInterviewRecord(encoding,comments,interviewer,noticeId,talentId,detail);

        if(rows!=1){
            return R.error("出错啦");
        }
        return R.success("面试成功");

    }
    @GetMapping("/getInterviewPromote")
    public R getInterviewPromote(Integer noticeId){

       String interviewPromote=interviewNoticeService.getInterviewPromote(noticeId);

       if(interviewPromote==null){
           return R.error("获取失败");
       }

       return R.success(interviewPromote);

    }

}
