package com.yzdx.AiInterviewer.controller.VxController;

import com.yzdx.AiInterviewer.comment.R;
import com.yzdx.AiInterviewer.entity.Resume;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxCompanyLikeDto;
import com.yzdx.AiInterviewer.entity.vxEntity.VxFeedBack;
import com.yzdx.AiInterviewer.entity.vxEntity.VxHelpEntity;
import com.yzdx.AiInterviewer.service.ResumeService;
import com.yzdx.AiInterviewer.service.UserService;
import com.yzdx.AiInterviewer.service.VxService.VxCompanyLikeService;
import com.yzdx.AiInterviewer.service.VxService.VxFeedBackService;
import com.yzdx.AiInterviewer.service.VxService.VxHelpService;
import com.yzdx.AiInterviewer.utiles.GetPostUntil;
import com.yzdx.AiInterviewer.utiles.WechatUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.codec.binary.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.json.JSONObject;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping("/vxUser")
public class VxUserController {
    @Autowired
    private ResumeService resumeService;
    @Autowired
    private UserService userService;
    @Autowired
    private VxCompanyLikeService vxCompanyLikeService;
    @Autowired
    private VxHelpService vxHelpService;
    @Autowired
    private VxFeedBackService vxFeedBackService;


    @ApiImplicitParams({
            @ApiImplicitParam(name = "js_code", required = true)
    }
    )
    @ApiOperation(value = "求职者登陆(vx)",notes = "")
    @PostMapping("/WxLogin")
    public R<String> R (@RequestParam(value = "js_code", required = true)  String js_code) throws Exception {

        //测试数据code
//        js_code = "0a3wuc0w3wd6M137CR2w3u7DoF1wuc0f";

        //微信获取session_key接口地址
        String wxLoginUrl = "https://api.weixin.qq.com/sns/jscode2session";
        //接口参数
        String param = "appid=wx7c972ceb65b45c49&secret=72ad166ce138375593026a2fc5bf9eee&js_code=" + js_code + "&grant_type=authorization_code";
        //调用获取session_key接口 请求方式get
        String jsonString = GetPostUntil.sendGet(wxLoginUrl, param);
        //因为json字符串是大括号包围，所以用JSONObject解析
        JSONObject json = new JSONObject(jsonString);
        //json解析session_key值
        String session_key = json.getString("session_key");

        System.out.println("session_key：" + session_key);
        //返回给前端
        return R.success(session_key);
    }

    @ApiImplicitParams({
            @ApiImplicitParam(name = "encryptedData", required = true),
            @ApiImplicitParam(name = "iv", required = true),
            @ApiImplicitParam(name = "sessionKey", required = true)
    }
    )
    @ApiOperation(value = "求职者登陆(vx)",notes = "")
    @PostMapping(value = "/decodeUserInfo")
    public R decodeUserInfo(@RequestParam(required = true, value = "encryptedData") String encryptedData,
                            @RequestParam(required = true, value = "iv") String iv,
                            @RequestParam(required = true, value = "sessionKey") String sessionKey
    ) throws Exception {
        byte[] encrypData = Base64.decodeBase64(encryptedData);
        byte[] ivData = Base64.decodeBase64(iv);
        byte[] sKey = Base64.decodeBase64(sessionKey);

        String decrypt = WechatUtils.decrypt(sKey,ivData,encrypData);
        System.out.println(decrypt);
        JSONObject jsonObject=new JSONObject(decrypt);
        String phoneNumber = jsonObject.getString("phoneNumber");
        return userService.vxLogin(phoneNumber);
    }


    /**
     *填写简历
     */
    @ApiImplicitParams({
            @ApiImplicitParam(name = "name",required = true),
            @ApiImplicitParam(name = "status",required = true),
            @ApiImplicitParam(name = "graduateTime",required = true),
            @ApiImplicitParam(name = "birthday",required = true),
            @ApiImplicitParam(name = "phone",required = true),
            @ApiImplicitParam(name = "email",required = true),
            @ApiImplicitParam(name = "vx",required = true),
            @ApiImplicitParam(name = "personalAdvantage",required = true),
            @ApiImplicitParam(name = "other",required = true),
            @ApiImplicitParam(name = "jobExpectation",required = true),
            @ApiImplicitParam(name = "workExperience",required = true),
            @ApiImplicitParam(name = "projectExperience",required = true),
            @ApiImplicitParam(name = "userId",required = true),
            @ApiImplicitParam(name = "sex",required = true),
    })
    @PostMapping("/write_resume")
    public R writeResume(@RequestParam(required = true, value = "name") String name,
                         @RequestParam(required = true,value = "avatar")String avatar,
                         @RequestParam(required = true, value = "status") String status,
                         @RequestParam(required = true, value = "graduateTime") String graduateTime,
                         @RequestParam(required = true, value = "birthday") String birthday,
                         @RequestParam(required = true, value = "phone") String phone,
                         @RequestParam(required = true, value = "email") String email,
                         @RequestParam(required = true, value = "vx") String vx,
                         @RequestParam(required = true, value = "personalAdvantage") String personalAdvantage,
                         @RequestParam(required = true, value = "other") String other,
                         @RequestParam(required = true, value = "education_background") String education_background,
                         @RequestParam(required = true, value = "jobExpectation") String jobExpectation,
                         @RequestParam(required = true, value = "workExperience") String workExperience,
                         @RequestParam(required = true, value = "projectExperience") String projectExperience,
                         @RequestParam(required = true, value = "userId") Integer userId,
                         @RequestParam(required = true, value = "sex") String sex){
        Map<String,Object> result = resumeService.writeResume( name, avatar,sex, status, graduateTime, birthday, phone,
                email, vx, personalAdvantage,
                other,education_background,jobExpectation,workExperience,projectExperience,userId);
        if(result==null){
            return R.error("提交失败，请重新输入");
        }
        return R.success(result);
    }
    /**
     *更新简历
     */
    @ApiImplicitParams({
            @ApiImplicitParam(name = "name",required = true),
            @ApiImplicitParam(name = "id",required = true),
            @ApiImplicitParam(name = "status",required = true),
            @ApiImplicitParam(name = "graduateTime",required = true),
            @ApiImplicitParam(name = "birthday",required = true),
            @ApiImplicitParam(name = "phone",required = true),
            @ApiImplicitParam(name = "email",required = true),
            @ApiImplicitParam(name = "vx",required = true),
            @ApiImplicitParam(name = "personalAdvantage",required = true),
            @ApiImplicitParam(name = "other",required = true),
            @ApiImplicitParam(name = "jobExpectation",required = true),
            @ApiImplicitParam(name = "workExperience",required = true),
            @ApiImplicitParam(name = "projectExperience",required = true),
            @ApiImplicitParam(name = "userId",required = true),
            @ApiImplicitParam(name = "sex",required = true),
    })

    @PostMapping("/update_resume")
    public R updateResume(@RequestParam(required = true, value = "name") String name,
                          @RequestParam(required = true, value = "id") Integer id,
                          @RequestParam(required = true,value = "avatar")String avatar,
                          @RequestParam(required = true, value = "status") String status,
                          @RequestParam(required = true, value = "graduateTime") String graduateTime,
                          @RequestParam(required = true, value = "birthday") String birthday,
                          @RequestParam(required = true, value = "phone") String phone,
                          @RequestParam(required = true, value = "email") String email,
                          @RequestParam(required = true, value = "vx") String vx,
                          @RequestParam(required = true, value = "personalAdvantage") String personalAdvantage,
                          @RequestParam(required = true, value = "other") String other,
                          @RequestParam(required = true, value = "education_background") String education_background,
                          @RequestParam(required = true, value = "jobExpectation") String jobExpectation,
                          @RequestParam(required = true, value = "workExperience") String workExperience,
                          @RequestParam(required = true, value = "projectExperience") String projectExperience,
                          @RequestParam(required = true, value = "userId") Integer userId,
                          @RequestParam(required = true, value = "sex") String sex
                          ){
        Map<String,Object> result = resumeService.updateResume(id,name,avatar, sex, status, graduateTime,
                birthday, phone, email, vx, personalAdvantage,
                other,education_background,jobExpectation,workExperience,projectExperience,userId);
        if(result==null){
            return R.error("提交失败，请重新输入");
        }
        return R.success(result);
    }

    /**
     * 获取简历
     * @param userId
     * @return
     */
    @GetMapping("/getResume")
public R getResume(Integer userId){

        Map<String,Object> result= resumeService.getResume(userId);

        if(result==null){
            return R.error("未填写简历，请先填写简历");
        }

      return R.success(result);
}



//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "expectationType",required = true),
//            @ApiImplicitParam(name = "position",required = true),
//            @ApiImplicitParam(name = "location",required = true),
//            @ApiImplicitParam(name = "userId",required = true),
//            @ApiImplicitParam(name = "salary",required = true),
//    })
//    @PostMapping("/add_jobExpectation")
//    public R addJobExpectation(@RequestParam(required = true, value = "expectationType") Integer expectationType,
//                               @RequestParam(required = true, value = "position") String position,
//                               @RequestParam(required = true, value = "location") String location,
//                               @RequestParam(required = true, value = "salary") String minSalary,
//                               @RequestParam(required = true, value = "salary") String maxSalary,
//                               @RequestParam(required = true, value = "userId") Integer userId) {
//        String salary=minSalary+maxSalary;
//        Integer rows= resumeService.addJobExpectation(expectationType,position,location,salary,userId);
//        if(rows!=1){
//            return R.error("保存失败，请重新输入");
//        }
//        return R.success("保存岗位期望成功");
//    }
//
//    /**
//     * 获取岗位期望列表
//     * @return
//     */
//
//    @GetMapping("/getJobExpectation")
//    public R getJobExpectation(@ApiParam("Integer userId") Integer userId){
//       List<JobExpectation> list= resumeService.getJobExpectation(userId);
//       return R.success(list);
//    }
//
//    /**
//     * 更新岗位期望信息
//     */
//    @ResponseBody
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "expectationType",required = true),
//            @ApiImplicitParam(name = "position",required = true),
//            @ApiImplicitParam(name = "location",required = true),
//            @ApiImplicitParam(name = "userId",required = true),
//            @ApiImplicitParam(name = "salary",required = true),
//    })
//    @PostMapping("/updateJobExpectation")
//    public R updateJobExpectation(@RequestParam(required = true, value = "expectationType") Integer expectationType,
//                                  @RequestParam(required = true, value = "position") String position,
//                                  @RequestParam(required = true, value = "id") Integer id,
//                                  @RequestParam(required = true, value = "location") String location,
//                                  @RequestParam(required = true, value = "salary") String salary,
//                                  @RequestParam(required = true, value = "userId") Integer userId){
//        Integer rows= resumeService.updateJobExpectation(id,expectationType,position,location,salary,userId);
//        if(rows!=1){
//            return R.error("保存失败，请重新输入");
//        }
//        return R.success("保存岗位期望成功");
//    }
//
//    /**
//     * 删除岗位期望
//     * @param id
//     * @return
//     */
//    @DeleteMapping("/deleteJobExpectation")
//    public R deleteJobExpectation(Integer id){
//       Integer rows= resumeService.deleteJobExpectation(id);
//       if(rows==-2){
//           return R.error("删除失败");
//       }
//       return R.success("删除成功");
//    }


    /**
     * 获取帮助列表
      * @return R
     */
    @GetMapping("/getHelpList")
    public R getHelpList(){

        List<VxHelpEntity> helpList = vxHelpService.getHelpList();

        return R.success(helpList);

    }

    /**
     * 获取企业关注列表
     * @param userId
     * @return
     */
    @GetMapping("/getCompanyLikeList")
    public R getCompanyLikeList(Integer userId){
        List<VxCompanyLikeDto> VxCompanyLikeDtos=vxCompanyLikeService.getCompanyLikeListById(userId);
        return R.success(VxCompanyLikeDtos);
    }

    /**
     * vx登录注册
     * @param phone
     * @param encoding
     * @param password
     * @return
     */
    @ApiImplicitParams({
            @ApiImplicitParam(name = "phone",required = true),
            @ApiImplicitParam(name = "encoding",required = true),
            @ApiImplicitParam(name = "password",required = true),
    })
    @PostMapping("/VxAdminLogin")
    public R adminLogin(@RequestParam(required = true, value = "phone") String phone,
                        @RequestParam(required = true, value = "encoding") String encoding,
                        @RequestParam(required = true, value = "password") String password){

         return userService.adminLogin(phone, encoding, password);
    }

    /**
     * 填写反馈
     */
    @PostMapping("/writeFeedBack")
    public R writeFeedBack(@RequestParam(required = true, value = "userid") Integer userid,
                           @RequestParam(required = true, value = "imgUrl") String imgUrl,
                           @RequestParam(required = true, value = "phone") String phone,
                           @RequestParam(required = true, value = "content") String content){
        Integer rows=vxFeedBackService.writeFeedBack(userid,imgUrl,phone,content);
        if (rows!=1){
            return R.error("提交失败");
        }
        return R.success("提交成功");
    }

    /**
     * 修改反馈
     */
    @PostMapping("/updateFeedBack")
    public R updateFeedBack(@RequestParam(required = true, value = "userid") Integer userid,
                            @RequestParam(required = true, value = "imgUrl") String imgUrl,
                            @RequestParam(required = true, value = "id") Integer id,
                            @RequestParam(required = true, value = "phone") String phone,
                            @RequestParam(required = true, value = "content") String content){
        Integer rows=vxFeedBackService.updateFeedBack(id,userid,imgUrl,phone,content);
        if (rows!=1){
            return R.error("提交失败");
        }
        return R.success("提交成功");
    }
    /**
     * 获取反馈
     */
    @GetMapping("/getFeedBack")
    public R getFeedBack(Integer userId){
       List<VxFeedBack> vxFeedBacks= vxFeedBackService.getFeedBack(userId);
       return R.success(vxFeedBacks);
    }
    @GetMapping("/getAllFeedBack")
    public R getAllFeedBack(Integer status){

        List<VxFeedBack> allFeedBack = vxFeedBackService.getAllFeedBack(status);

        return R.success(allFeedBack);

    }
    @GetMapping("/changeFeedBackStatus")
    public R changeFeedBackStatus(Integer id,Integer userId){

        Integer rows=vxFeedBackService.changeFeedBackStatus(id,userId);

        return R.success("修改成功");

    }
}

