package com.yzdx.AiInterviewer.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel("工作实体类")
@TableName("Job_list")
public class JobEntity extends BaseEntity {

    @ApiModelProperty("岗位id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    @ApiModelProperty("工作地址")
    private String address;
    @ApiModelProperty("详细地址")
    private String addressDetail;
    @ApiModelProperty("岗位详情")
    private String details;
    @ApiModelProperty("岗位名称")
    private String jobName;
    @ApiModelProperty("上班时间")
    private String startTime;
    @ApiModelProperty("下班时间")
    private String endTime;
    @ApiModelProperty("岗位tips")
    private String jobTips;
    @ApiModelProperty("岗位类型")
    private Integer jobType;
    @ApiModelProperty("最低工资")
    private String minSalary;
    @ApiModelProperty("最高工资")
    private String maxSalary;
    @ApiModelProperty("招聘最少人数")
    private String minNumber;
    @ApiModelProperty("招聘最多人数")
    private String maxNumber;
    @ApiModelProperty("学历要求")
    private Integer requirement;
    @ApiModelProperty("公司编码")
    private String companyEncoding;
    @ApiModelProperty("岗位状态,0:禁用 1：启用")
    private Integer status;
    @ApiModelProperty("岗位福利")
    private String jobWelfale;
}
