package com.yzdx.AiInterviewer.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.yzdx.AiInterviewer.entity.JobEntity;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface JobMapper extends BaseMapper<JobEntity> {
    @Select("WITH CompanyFullAddress AS (  \n" +
            "    SELECT   \n" +
            "        id, \n" +
            "        CONCAT(adress, addressDetail) AS full_address   \n" +
            "    FROM   \n" +
            "        company  \n" +
            "),  \n" +
            "CompanyCoordinates AS (  \n" +
            "    SELECT  \n" +
            "        id,  \n" +
            "        full_address,  \n" +
            "        Geocode(full_address).latitude AS company_latitude,  \n" +
            "        Geocode(full_address).longitude AS company_longitude  \n" +
            "    FROM  \n" +
            "        CompanyFullAddress  \n" +
            "),  \n" +
            "InputCoordinates AS (  \n" +
            "    SELECT  \n" +
            "        Geocode(#{address}).latitude AS input_latitude,  \n" +
            "        Geocode(#{address}).longitude AS input_longitude  \n" +
            ")  \n" +
            "SELECT   \n" +
            "    c.id,   \n" +
            "    c.full_address,   \n" +
            "    (6371 * acos(cos(radians(i.input_latitude))   \n" +
            "    * cos(radians(c.company_latitude))   \n" +
            "    * cos(radians(c.company_longitude) - radians(i.input_longitude))   \n" +
            "    + sin(radians(i.input_latitude))   \n" +
            "    * sin(radians(c.company_latitude)))) AS distance_in_km  \n" +
            "FROM   \n" +
            "    CompanyCoordinates c, InputCoordinates i  \n" +
            "ORDER BY   \n" +
            "    distance_in_km ASC;")
    List<JobEntity> searchJob(String jobName,String address);
    
}
