package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.Company;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxCompanyDetailDto;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxCompanyLikeDto;

import java.util.List;

public interface CompanyService extends IService<Company> {

    /**
     * 获取公司详情
     * @param encoding 公司编码
     * @return 公司详情对象
     *
     * */
    VxCompanyDetailDto getCompanyDetail(String encoding);
/**
 * 更新公司详情
 * @param userId 人的id
 * @param encoding 公司的编码
 * @param address 公司地址
 * @param companyDetail 公司详情
 * @param addressDetail 公司详情地址
 * @param companyName 公司名称
 * @param creditCode 公司统一编码
 * @param established 公司的注册资金
 * @param images 公司图片
 * @param legalRepresentative 法定人
 * @param registeredCapital 注册资金
 * @param treatment 公司待遇
 * @return 影响的行数
 *
 * */
    Integer updateCompanyDetail(String address,
                                String addressDetail,
                                String type,
                                String companyAllName,
                                String companyDetail,
                                String companyName,
                                String creditCode,
                                String encoding,
                                String established,
                                String images,
                                String legalRepresentative,
                                String treatment,
                                String registeredCapital,
                                Integer userId,
                                String companyLogo,
                                String staffNumber);


    //----------------------------------------------vx--------------------------------------------------

    List<VxCompanyLikeDto> searchCompanyList(String searchName, String address);
}
