package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.BackgroundEntity;

import java.util.List;

public interface InterviewBackgroundService extends IService<BackgroundEntity> {

    /**
     * 获取公司背景图片
     * @param encoding 公司编码
     * @return 背景图片列表
     * */
    List<BackgroundEntity> getBackgroundList(String encoding);


    /**
     * 添加背景图片
     * @param name 图片名称
     * @param encoding 公司编码
     * @param userId 添加人的id
     * @param image 添加图片的地址
     * @param filename 添加的文件名
     * @return 映像的行数
     *
     * */
    Integer addBackgroundLogo(String name,String encoding,String image,Integer userId,String filename);

    /**
     * 删除背景图
     * @param id 图片id
     * @return 映像的行数
     *
     * */
    Integer deleteBackgroundById(Integer id);
}
