package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.ImagesEntity;
import com.yzdx.AiInterviewer.entity.LogoEntity;
import com.yzdx.AiInterviewer.entity.dto.ImageDto;

import java.util.List;

public interface InterviewImagesService extends IService<ImagesEntity> {

    /**
     * 获取面试管形象
     * @param encoding 公司编码
     * @return 形象图片列表
     * */
    List<ImagesEntity> getImagesList(String encoding);

    /**
     * 添加形象图片
     * @param name 图片名称
     * @param encoding 公司编码
     * @param userId 添加人的id
     * @param image 添加图片的地址
     * @param filename 添加的文件名
     * @return 映像的行数
     *
     * */
    Integer addImage(String name,String encoding,String image,String video,Integer userId,String filename,String sex);

    /**
     * 删除logo
     * @param id 图片id
     * @return 映像的行数
     *
     * */
    Integer deleteImageById(Integer id);
    /**
     * 生成数字人
     * @param imageId 形象ID
     * @return ImageDto
     *
     * */
    ImageDto getDigitalHumanById(Integer imageId);

}
