package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.LogoEntity;

import java.util.List;

public interface InterviewLogoService extends IService<LogoEntity> {

    /**
     * 获取公司logo
     * @param encoding 公司编码
     * @return logo列表
     * */
    List<LogoEntity> getLogoList(String encoding);

    /**
     * 添加logo
     * @param name 图片名称
     * @param encoding 公司编码
     * @param userId 添加人的id
     * @param image 添加图片的地址
     * @param filename 添加的文件名
     * @return 映像的行数
     *
     * */
    Integer addAddLogo(String name,String encoding,String image,Integer userId,String filename);

    /**
     * 删除logo
     * @param id 图片id
     * @return 映像的行数
     *
     * */
    Integer deleteLogoById(Integer id);
}
