package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxNoticeDto;
import com.yzdx.AiInterviewer.entity.vxEntity.VxInterviewNotice;

import java.util.List;

public interface InterviewNoticeService extends IService<VxInterviewNotice> {
/**
 * 添加面试通知
 * @param encoding 发起通知的公司编码
 * @param recipient 接收人id
 * @param jobId 面试的岗位id
 * @param postId 投递时的招聘id
 * @param userId 操作人的id
 * @param endTime 结束时间
 * @return 影响的行数
 *
 * */
    Integer addInterviewNotice(String encoding,Integer recipient,Integer jobId,Integer postId,Integer userId,String promote,String selectQuestions,Integer applicationId,String endTime);


    /**
     * 求职者查看面试通知
     * @param userId 查询的用户ID
     *
     * */
    List<VxNoticeDto> getInterviewNoticeByUserId(Integer userId);

    /**
     * 获取面试的promote
     * @param noticeId 面试通知id
     * @return promote
     * */
    String getInterviewPromote(Integer noticeId);
}
