package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.JobPosting;
import com.yzdx.AiInterviewer.entity.dto.JobPostingDto;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface JobPostingService extends IService<JobPosting> {

    /**
     *招聘发布
     * @param name 招聘名称
     * @param startTime 招聘开始时间
     * @param endTime  招聘结束时间
     * @param encoding 招聘公司编码
     * @param checkList 招聘岗位IDs
     * @param userId 添加人的ID
     * @return 影响的行数
     * */

    Integer addJobPosting(String name, String startTime, String endTime, String checkList, Integer userId, String encoding);
    /**
     *招聘修改
     * @param id 招聘信息id
     * @param name 招聘名称
     * @param startTime 招聘开始时间
     * @param endTime  招聘结束时间
     * @param checkList 招聘岗位IDs
     * @param userId 添加人的ID
     * @return 影响的行数
     * */

    Integer updateJobPosting(Integer id,String name, String startTime, String endTime,
                             String checkList, Integer userId,Integer status);


    /**
     * 招聘删除
     * @param id 招聘信息ID
     * return 影响的行数
     * */

    Integer deleteJobPosting(Integer id);

    /**
     * 获取招聘列表
     * @param encoding 公司编码
     * @return JobPostingDto列表
     *
     * */
    List<JobPostingDto> getJobPostingList(String encoding);

    List<Map<String, Object>> getPostingInfoList(String encoding);

}
