package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.QuestionBank;

import java.util.List;

/**
 * 题库业务层
 * */
public interface QuestionBankService extends IService<QuestionBank> {

    /**
     * 获取题库列表
     * @param encoding 公司编码
     * @return List<QuestionBank> 题库列表
     * */
    List<QuestionBank> getTypeList(String encoding);
/**
 * 搜索题库类型
 * @param name 题库名
 * @param encoding 公司编码
 * @return 题库类型列表
 * */

    List<QuestionBank> searchTypeList(String name,String type,String encoding);
    /**
     * 获取题库列表
     * @param encoding 公司编码
     * @param type 题库类型
     * @return List<QuestionBank> 题库列表
     * */
    List<QuestionBank> getTypeListByType(String encoding,Integer type);
/**
 * 添加题库信息
 * @param typeName 添加的题库名
 * @param encoding 添加题库的公司编码
 * @param userId 添加人
 * @return 返回影响行数
 * */
    Integer addTypeName(String typeName,String encoding,String description,Integer type,Integer userId);
    /**
     * 根据题库id删除题库信息
     * @param typeId 删除的题库id
     * @return 返回影响行数
     * @return 影响的行数
     * */
    Integer deleteType(Integer typeId);

    /**
     * @param typeId 修改的题库id
     * @param typeName 修改的题库名称
     * @param userId 修改人的id
     * @return 影响的行数
     * */
    Integer changeType(Integer typeId,String description,Integer type,String typeName,Integer userId);
    /**
     * 根据id查询题库
     * @param id 题库id
     * @return 返回一个题库对象
     * */

    QuestionBank getBankById(Integer id);

}
