package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.Question;
import com.yzdx.AiInterviewer.entity.dto.QuestionDto;

import java.util.List;

public interface QuestionService extends IService<Question> {

    /**
     * 获取题目列表
     * @param encoding 公司编码
     * @return 题目列表
     * */
    List<QuestionDto> getQuestionList(String encoding);
/**
 * 搜索题目
 * @param name 题目名称
 * @param type 题库类型
 * @param encoding 公司编码
 * @return 题目列表
 *
 *
 * */
    List<QuestionDto> searchQuestionList(String name,String type,String encoding);
    /**
     * 增加题目
     * @param encoding 公司编码
     * @param bankId 题库类型id
     * @param details 题目详情
     * @param answer 题目的预设答案
     * @param title 题目标题
     * @param userId 用户id
     * @return 改变的行数
     * */
    Integer addQuestion(String title,Integer bankId,String details,String answer,String encoding,Integer userId);
    /**
     * 修改题目
     * @param id 题目ID
     * @param encoding 公司编码
     * @param bankId 题库类型id
     * @param details 题目详情
     * @param answer 题目预设答案
     * @param title 题目标题
     * @param userId 用户id
     * @return 改变的行数
     * */
    Integer updateQuestion(Integer id,String title,Integer bankId,String details,String answer,String encoding,Integer userId);



    /**
     * 删除题目
     * @param id 删除题目的id
     * @return 改变的行数
     * */
    Integer deleteQuestion(Integer id);


}
