package com.yzdx.AiInterviewer.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.SharedQuestion;
import com.yzdx.AiInterviewer.entity.dto.SharedQuestionBankDto;
import com.yzdx.AiInterviewer.entity.dto.SharedQuestionDto;

import java.util.List;

public interface SharedQuestionService extends IService<SharedQuestion> {

    /**
     * 增加题目
     * @param sharedBankId 分享题库id
     * @param selectQuestionId 分享题目的id
     * @param userId 分享人
     * @return 影响的行数
     *
     * */
    String addSharedQuestions(Integer sharedBankId, List<Integer> selectQuestionId,Integer userId,String encoding);


    List<SharedQuestionDto> getSharedQuestionList();

    List<SharedQuestionDto> getSharedQuestionListBySharedBankId(Integer SharedBankId);

    /**
     * 根据分享题目名称搜索分享题目
     * @param searchName
     * @return 分享的题目
     */
    List<SharedQuestionDto> searchSharedQuestion(String searchName);

    /**
     * 根据分享题目id添加题目信息
     * @param selectSharedQuestionIds
     * @param bankId
     * @param userId
     * @param encoding
     * @return 题目
     */
    String addQuestionFromShare(List<Integer> selectSharedQuestionIds,Integer bankId,Integer userId,String encoding);


    /**
     * 根据公司编码获取本公司分享的题库
     * @param encoding
     * @return 题库列表
     */
    List<SharedQuestionDto> getOurQuestionList(String encoding);

    /**
     * 根据公司编码和题库名称搜索题库
     * @param encoding
     * @param searchName
     * @return 题库列表
     */
    List<SharedQuestionDto> searchOurSharedQuestion(String encoding,String searchName);

    /**
     * 删除分享题目
     * @return 影响的行数
     * */


    Integer deleteOurSharedQuestion(List<Integer> ids);

    /**
     * 修改分享题库详情
     * @param id 分享题目ID
     * @param title 题目标题
     * @param details 题目详情
     * @param answer 题目预设答案
     * @param bankId 分享题库ID
     * @param userId 修改人ID
     *
     * */
    Integer updateOurSharedQuestion(Integer id,
                            String title,
                            String details ,
                            String answer,
                            Integer bankId ,
                            Integer userId );


}
