package com.yzdx.AiInterviewer.service.VxService;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxInterviewApplicationDto;
import com.yzdx.AiInterviewer.entity.vxEntity.VxInterviewApplication;

import java.util.List;

public interface VxInterviewApplicationService extends IService<VxInterviewApplication> {
    /**
     * vx投递简历
     * @param userId 用户ID
     * @param jobId 投递岗位id
     * @param postingId 招聘的id
     * @param companyEncoding 投递的公司
     *
     * */

    Integer addInterviewApplication(Integer jobId, Integer userId, Integer postingId, String companyEncoding);


    /**
     * Hr端获取面试申请
     * @param jobId 岗位id
     * @param companyEncoding 公司编码
     * @return List<VxInterviewApplicationDto>
     * */
    List<VxInterviewApplicationDto> getApplicationList(String companyEncoding, Integer jobId);

    /**
     * 拒绝面试申请
     * @param id 申请表id
     * @return 影响的行数
     * */
    Integer disagreeApplication(Integer id);

    /**
     * @param searchName 搜索人的名称
     * @param encoding 所搜人投递的公司编码
     * @return  List<VxInterviewApplicationDto>
     *
     * */
    List<VxInterviewApplicationDto> searchApplicationByName(String searchName, String encoding);

}
