package com.yzdx.AiInterviewer.service.VxService;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxInterviewRecordDto;
import com.yzdx.AiInterviewer.entity.dto.InterviewRecordDto;
import com.yzdx.AiInterviewer.entity.vxEntity.VxInterviewRecord;

import java.util.List;

public interface VxInterviewRecordService extends IService<VxInterviewRecord> {


    List<VxInterviewRecordDto> getInterviewRecordList(Integer userId);


    List<VxInterviewRecordDto> searchInterviewRecordList(String searchCompany,Integer userId);

    /**
     * 添加面试记录
     * @param encoding 公司编码
     * @param interviewer 面试者id
     * @param comments 面试评语
     * @param noticeId 面试通知id
     * @param detail 面试详情
     * @param talentId 人才画像id
     * @return 影响的行数
     *
     * */

    Integer addInterviewRecord(String encoding, String comments, Integer interviewer, Integer noticeId,Integer talentId,String detail);

    /**
     * 后台网页获取
     * @param jobId 岗位id
     * @param encoding 公司编码
     * @param postId 招聘ID
     * @return List<InterviewRecordDto>
     *
     * */

    List<InterviewRecordDto> getInterviewRecords(Integer postId, Integer jobId, String encoding,Integer status);

    /**
     * 通过面试
     * @param postId 招聘Id
     * @param jobId 岗位id
     * @param userList 通过人的id
     * @return 影线的行数
     *
     * */
    Integer agreeUsersPassInterview(Integer jobId, Integer postId, String userList,Integer userId);

    /**
     * 根据用户id获取面试记录
     * @param userId 用户id
     * @return List<InterviewRecordDto>
     *
     * */
    List<InterviewRecordDto> getInterviewRecordListByUserId(Integer userId);
}
