package com.yzdx.AiInterviewer.service.VxService.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yzdx.AiInterviewer.entity.Company;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxCompanyLikeDto;
import com.yzdx.AiInterviewer.entity.dto.JobDto;
import com.yzdx.AiInterviewer.entity.vxEntity.VxCompanyLike;
import com.yzdx.AiInterviewer.entity.vxEntity.VxJobLike;
import com.yzdx.AiInterviewer.mapper.CompanyMapper;
import com.yzdx.AiInterviewer.mapper.VxMapper.VxCompanyLikeMapper;
import com.yzdx.AiInterviewer.service.JobListService;
import com.yzdx.AiInterviewer.service.VxService.VxCompanyLikeService;
import com.yzdx.AiInterviewer.utiles.TimeUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class VxCompanyLikeServiceImpl extends ServiceImpl<VxCompanyLikeMapper, VxCompanyLike> implements VxCompanyLikeService {
    @Autowired
    private VxCompanyLikeMapper vxCompanyLikeMapper;
    @Autowired
    private CompanyMapper companyMapper;
    @Autowired
    private JobListService jobListService;
    @Override
    public List<VxCompanyLikeDto> getCompanyLikeListById(Integer userId) {

        LambdaQueryWrapper<VxCompanyLike> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(VxCompanyLike::getUserId,userId);

        List<VxCompanyLike> vxCompanyLikes = vxCompanyLikeMapper.selectList(queryWrapper);

        List<VxCompanyLikeDto> vxCompanyLikeDtos=vxCompanyLikes.stream().map(item->{

            VxCompanyLikeDto vxCompanyLikeDto=new VxCompanyLikeDto();

            BeanUtils.copyProperties(item,vxCompanyLikeDto);
            // 得到公司编码
            LambdaQueryWrapper<Company> queryWrapper1=new LambdaQueryWrapper<>();

            queryWrapper1.eq(Company::getEncoding,vxCompanyLikeDto.getCompanyEncoding());

            Company company = companyMapper.selectOne(queryWrapper1);

            vxCompanyLikeDto.setCompanyEncoding(company.getEncoding());

            vxCompanyLikeDto.setCompanyName(company.getCompanyName());
            //得到公司类型


            vxCompanyLikeDto.setCompanyType(company.getType());
            //得到公司logo url

            vxCompanyLikeDto.setCompanyImgUrl(company.getCompanyLogo());
            //得到企业人数

            vxCompanyLikeDto.setStaffNum(company.getStaffNumber());
            //得到相关信息
            List<JobDto> jobList = jobListService.getJobList(company.getEncoding());
            List<Map<String,Object>> jobRelatives=jobList.stream().map(i->{
                Map<String,Object> jobRelative=new HashMap<>();

                jobRelative.put("jobname",i.getJobName());
                jobRelative.put("salary",i.getSalary());
                return jobRelative;

            }).collect(Collectors.toList());
            vxCompanyLikeDto.setJobRelative(jobRelatives);
            return vxCompanyLikeDto;
        }).collect(Collectors.toList());
        return vxCompanyLikeDtos;
    }

    @Override
    public Integer addCompanyLike(String companyEncoding, Integer userId) {
        LambdaQueryWrapper<VxCompanyLike> queryWrapper=new LambdaQueryWrapper<>();
        queryWrapper.eq(VxCompanyLike::getCompanyEncoding,companyEncoding);
        VxCompanyLike vxCompanyLike = vxCompanyLikeMapper.selectOne(queryWrapper);
        if(vxCompanyLike!=null){
            return -1;
        }
        VxCompanyLike vxCompanyLike1=new VxCompanyLike();
        vxCompanyLike1.setCompanyEncoding(companyEncoding);
        vxCompanyLike1.setUserId(userId);
        vxCompanyLike1.setCreateTime(TimeUtil.getTime());
        vxCompanyLike1.setCreateUser(userId);
        Integer row = vxCompanyLikeMapper.insert(vxCompanyLike1);
        return row;
    }

    @Override
    public Integer cancelCompanyLike(String companyEncoding,Integer userId) {
        LambdaQueryWrapper<VxCompanyLike> queryWrapper=new LambdaQueryWrapper<>();
        queryWrapper.eq(VxCompanyLike::getCompanyEncoding,companyEncoding).eq(VxCompanyLike::getUserId,userId);
        VxCompanyLike vxJobLike = vxCompanyLikeMapper.selectOne(queryWrapper);
        if(vxJobLike==null){
            return -1;
        }
        Integer row = vxCompanyLikeMapper.delete(queryWrapper);
        return row;
    }
}