package com.yzdx.AiInterviewer.service.VxService.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yzdx.AiInterviewer.entity.vxEntity.VxFeedBack;
import com.yzdx.AiInterviewer.mapper.VxMapper.VxFeedBackMapper;
import com.yzdx.AiInterviewer.service.VxService.VxFeedBackService;
import com.yzdx.AiInterviewer.utiles.PhoneUtils;
import com.yzdx.AiInterviewer.utiles.TimeUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class VxFeedBackServiceImpl extends ServiceImpl<VxFeedBackMapper, VxFeedBack> implements VxFeedBackService {
    @Autowired
    private VxFeedBackMapper vxFeedBackMapper;
    @Override
    public Integer writeFeedBack(Integer userid, String imgUrl, String phone, String content) {

        VxFeedBack vxFeedBack1=new VxFeedBack();
        vxFeedBack1.setContent(content);
        vxFeedBack1.setPhone(phone);
        vxFeedBack1.setImgUrl(imgUrl);
        vxFeedBack1.setUserId(userid);
        vxFeedBack1.setCreateUser(userid);
        vxFeedBack1.setUpdateUser(userid);
        vxFeedBack1.setCreateTime(TimeUtil.getTime());
        vxFeedBack1.setUpdateTime(TimeUtil.getTime());
        Integer row = vxFeedBackMapper.insert(vxFeedBack1);
        return row;
    }

    @Override
    public Integer updateFeedBack(Integer id, Integer userid, String imgUrl, String phone, String content) {
        VxFeedBack vxFeedBack=new VxFeedBack();
        vxFeedBack.setId(id);
        vxFeedBack.setUserId(userid);
        vxFeedBack.setCreateUser(userid);
        vxFeedBack.setUpdateUser(userid);
        vxFeedBack.setPhone(phone);
        vxFeedBack.setContent(content);
        vxFeedBack.setImgUrl(imgUrl);
        vxFeedBack.setCreateTime(TimeUtil.getTime());
        vxFeedBack.setUpdateTime(TimeUtil.getTime());
        Integer row=vxFeedBackMapper.updateById(vxFeedBack);
        return row;
    }

    @Override
    public List<VxFeedBack> getFeedBack(Integer userId) {
        LambdaQueryWrapper<VxFeedBack> queryWrapper=new LambdaQueryWrapper<>();
        queryWrapper.eq(VxFeedBack::getUserId,userId);
        List<VxFeedBack> vxFeedBacks = vxFeedBackMapper.selectList(queryWrapper);
        return vxFeedBacks;
    }

    @Override
    public List<VxFeedBack> getAllFeedBack(Integer status) {

        List<VxFeedBack> allFeedBack = vxFeedBackMapper.getAllFeedBack(status);

        allFeedBack=allFeedBack.stream().map(item->{
            String phone=item.getPhone();

            String s = PhoneUtils.blurPhone(phone);

            item.setPhone(s);
            return item;
        }).collect(Collectors.toList());

        return allFeedBack;
    }

    @Override
    public Integer changeFeedBackStatus(Integer id,Integer userId) {
        VxFeedBack vxFeedBack = vxFeedBackMapper.selectById(id);

        vxFeedBack.setStatus(2);
        vxFeedBack.setUpdateUser(userId);
        vxFeedBack.setUpdateTime(TimeUtil.getTime());
       return vxFeedBackMapper.updateById(vxFeedBack);
    }


}
