package com.yzdx.AiInterviewer.service.VxService.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yzdx.AiInterviewer.entity.Company;
import com.yzdx.AiInterviewer.entity.JobEntity;
import com.yzdx.AiInterviewer.entity.vxEntity.VxJobLike;
import com.yzdx.AiInterviewer.entity.VxEntityDto.VxJobLikeDto;
import com.yzdx.AiInterviewer.mapper.VxMapper.VxJobLikeMapper;
import com.yzdx.AiInterviewer.service.CompanyService;
import com.yzdx.AiInterviewer.service.JobListService;
import com.yzdx.AiInterviewer.service.VxService.VxJobLikeService;
import com.yzdx.AiInterviewer.utiles.TimeUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class VxJobLikeServiceImpl extends ServiceImpl<VxJobLikeMapper, VxJobLike> implements VxJobLikeService {

    @Autowired
    private VxJobLikeMapper vxJobLikeMapper;
    @Autowired
    private JobListService jobListService;
    @Autowired
    private CompanyService companyService;

    @Override
    public List<VxJobLikeDto> getJobLikeListById(Integer userId) {
        LambdaQueryWrapper<VxJobLike> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(VxJobLike::getUserId,userId);

        List<VxJobLike> vxJobLikes = vxJobLikeMapper.selectList(queryWrapper);

        if(vxJobLikes.size()==0){
            return null;
        }

        List<VxJobLikeDto> vxJobLikeDtoList=vxJobLikes.stream().map(item->{
            VxJobLikeDto vxJobLikeDto=new VxJobLikeDto();

            BeanUtils.copyProperties(item,vxJobLikeDto);

            JobEntity findJob = jobListService.getJobById(item.getJobId());

            vxJobLikeDto.setJobName(findJob.getJobName());

            vxJobLikeDto.setSalary(findJob.getMinSalary()+"-"+findJob.getMaxSalary());

            Company companyDetail = companyService.getCompanyDetail(findJob.getCompanyEncoding());

            vxJobLikeDto.setCompany(companyDetail.getCompanyName());

            vxJobLikeDto.setStaffNumber(companyDetail.getStaffNumber());

            vxJobLikeDto.setLabel(findJob.getJobTips());

            vxJobLikeDto.setPosition(findJob.getAddressDetail());


            return vxJobLikeDto;
        }).collect(Collectors.toList());

        return vxJobLikeDtoList;
    }

    @Override
    public Integer addJobLike(Integer jobId, Integer userId) {

        LambdaQueryWrapper<VxJobLike> queryWrapper =new LambdaQueryWrapper<>();

        queryWrapper.eq(VxJobLike::getJobId,jobId);

        VxJobLike vxJobLike1 = vxJobLikeMapper.selectOne(queryWrapper);

        if(vxJobLike1!=null){
            return -1;
        }

        VxJobLike vxJobLike=new VxJobLike();

       vxJobLike.setJobId(jobId);

       vxJobLike.setUserId(userId);

       vxJobLike.setCreateTime(TimeUtil.getTime());

       vxJobLike.setCreateUser(userId);

        Integer rows = vxJobLikeMapper.insert(vxJobLike);

        return rows;

    }

    @Override
    public Integer cancelJobLike(Integer jobId,Integer userId) {
        LambdaQueryWrapper<VxJobLike> queryWrapper=new LambdaQueryWrapper<>();
        queryWrapper.eq(VxJobLike::getJobId,jobId).eq(VxJobLike::getUserId,userId);
        VxJobLike vxJobLike = vxJobLikeMapper.selectOne(queryWrapper);
        if(vxJobLike==null){
            return -1;
        }
        Integer row = vxJobLikeMapper.delete(queryWrapper);
        return row;
    }
}
