package com.yzdx.AiInterviewer.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yzdx.AiInterviewer.entity.BackgroundEntity;
import com.yzdx.AiInterviewer.entity.InterviewSetting;
import com.yzdx.AiInterviewer.mapper.InterviewBackgroundMapper;
import com.yzdx.AiInterviewer.mapper.InterviewSettingMapper;
import com.yzdx.AiInterviewer.service.InterviewBackgroundService;
import com.yzdx.AiInterviewer.utiles.TimeUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class InterviewBackgroundServiceImpl extends ServiceImpl<InterviewBackgroundMapper, BackgroundEntity> implements InterviewBackgroundService {

    @Autowired
    private  InterviewBackgroundMapper backgroundMapper;
    @Autowired
    private InterviewSettingMapper interviewSettingMapper;

    @Override
    public List<BackgroundEntity> getBackgroundList(String encoding) {
        LambdaQueryWrapper<BackgroundEntity> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(BackgroundEntity::getEncoding,encoding);

        List<BackgroundEntity> backgroundList = backgroundMapper.selectList(queryWrapper);

        return backgroundList;
    }

    @Override
    public Integer addBackgroundLogo(String name, String encoding, String image, Integer userId, String filename) {
        BackgroundEntity backgroundEntity=new BackgroundEntity();
        backgroundEntity.setCreateUser(userId);
        backgroundEntity.setCreateTime(TimeUtil.getTime());
        backgroundEntity.setImage(image);
        backgroundEntity.setPicName(name);
        backgroundEntity.setEncoding(encoding);
        backgroundEntity.setFilename(filename);

        Integer rows = backgroundMapper.insert(backgroundEntity);
        return rows;
    }

    @Override
    public Integer deleteBackgroundById(Integer id) {

        LambdaQueryWrapper<InterviewSetting> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(InterviewSetting::getBackgroundId,id);

        List<InterviewSetting> interviewSettings = interviewSettingMapper.selectList(queryWrapper);

        if(interviewSettings.size()!=0){
            return -1;
        }
        Integer rows = backgroundMapper.deleteById(id);

        return rows;
    }
}
