package com.yzdx.AiInterviewer.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yzdx.AiInterviewer.entity.ImagesEntity;
import com.yzdx.AiInterviewer.entity.InterviewSetting;
import com.yzdx.AiInterviewer.entity.LogoEntity;
import com.yzdx.AiInterviewer.entity.dto.ImageDto;
import com.yzdx.AiInterviewer.mapper.InterviewImagesMapper;
import com.yzdx.AiInterviewer.mapper.InterviewSettingMapper;
import com.yzdx.AiInterviewer.service.InterviewImagesService;
import com.yzdx.AiInterviewer.utiles.TimeUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class InterviewImagesServiceImpl extends ServiceImpl<InterviewImagesMapper, ImagesEntity> implements InterviewImagesService {

    @Autowired
    private InterviewImagesMapper imagesMapper;

    @Autowired
    private InterviewSettingMapper interviewSettingMapper;
    @Override
    public List<ImagesEntity> getImagesList(String encoding) {

        LambdaQueryWrapper<ImagesEntity> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(ImagesEntity::getEncoding,encoding);

        List<ImagesEntity> imagesList = imagesMapper.selectList(queryWrapper);

        return imagesList;
    }

    @Override
    public Integer addImage(String name, String encoding, String image, String video,Integer userId, String filename,String sex) {
       if(video.equals("")||video==null){
           ImagesEntity imageEntity=new ImagesEntity();
           imageEntity.setCreateUser(userId);
           imageEntity.setCreateTime(TimeUtil.getTime());
           imageEntity.setImage(image);
           imageEntity.setVideo("");
           imageEntity.setSex(sex);
           imageEntity.setPicName(name);
           imageEntity.setEncoding(encoding);
           imageEntity.setFilename(filename);

           Integer rows = imagesMapper.insert(imageEntity);
           return rows;
       }else{
           ImagesEntity imageEntity=new ImagesEntity();
           imageEntity.setCreateUser(userId);
           imageEntity.setCreateTime(TimeUtil.getTime());
           imageEntity.setVideo(video);
           imageEntity.setImage("");
           imageEntity.setSex(sex);
           imageEntity.setPicName(name);
           imageEntity.setEncoding(encoding);
           imageEntity.setFilename(filename);
           Integer rows = imagesMapper.insert(imageEntity);
           return rows;
       }
    }

    @Override
    public Integer deleteImageById(Integer id) {

        LambdaQueryWrapper<InterviewSetting> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(InterviewSetting::getImagesId,id);

        List<InterviewSetting> interviewSettings = interviewSettingMapper.selectList(queryWrapper);

        if(interviewSettings.size()!=0){
            return -1;
        }
        Integer rows = imagesMapper.deleteById(id);

        return rows;
    }

    @Override
    public ImageDto getDigitalHumanById(Integer imageId) {
        LambdaQueryWrapper<ImagesEntity> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(ImagesEntity::getId,imageId);

        ImagesEntity imagesEntity = imagesMapper.selectOne(queryWrapper);

        ImageDto imageDto=new ImageDto();

        BeanUtils.copyProperties(imagesEntity,imageDto);

        if(imagesEntity.getImage()==null||imagesEntity.getImage().equals("")){

            imageDto.setStatic(false);

        }else {
            imageDto.setStatic(true);
        }
        return imageDto;
    }
}
