package com.yzdx.AiInterviewer.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yzdx.AiInterviewer.entity.*;
import com.yzdx.AiInterviewer.entity.dto.InvitePromoteDto;
import com.yzdx.AiInterviewer.mapper.InvitePromoteMapper;
import com.yzdx.AiInterviewer.mapper.JobPostingMapper;
import com.yzdx.AiInterviewer.mapper.QuestionBankMapper;
import com.yzdx.AiInterviewer.mapper.QuestionMapper;
import com.yzdx.AiInterviewer.service.CompanyService;
import com.yzdx.AiInterviewer.service.InvitePromoteService;
import com.yzdx.AiInterviewer.service.JobListService;
import com.yzdx.AiInterviewer.utiles.TimeUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class InvitePromoteServiceImpl extends ServiceImpl<InvitePromoteMapper, InvitePromote> implements InvitePromoteService {

    @Autowired
    private InvitePromoteMapper invitePromoteMapper;

    @Autowired
    private CompanyService companyService;
    @Autowired
    private JobListService jobListService;
    @Autowired
    private JobPostingMapper jobPostingMapper;
    @Autowired
    private QuestionMapper questionMapper;
    @Autowired
    private QuestionBankMapper questionBankMapper;



    @Override
    public Integer addInvitePromote(String encoding, Integer postId, String startTime,
                                    String endTime, String question, String promote,
                                    Integer inviteUser,Integer userId,Integer jobId) {


        LambdaQueryWrapper<InvitePromote> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(InvitePromote::getJobId,jobId).eq(InvitePromote::getPostId,postId)
                .eq(InvitePromote::getEncoding,encoding).eq(InvitePromote::getInviteUser,inviteUser);

        InvitePromote invitePromote = invitePromoteMapper.selectOne(queryWrapper);

        if(invitePromote!=null){
            return -1;
        }

        InvitePromote addInvitePromote=new InvitePromote();

        addInvitePromote.setEncoding(encoding);

        addInvitePromote.setPostId(postId);

        addInvitePromote.setStartTime(startTime);

        addInvitePromote.setEndTime(endTime);

        addInvitePromote.setQuestion(question);

        addInvitePromote.setPromote(promote);

        addInvitePromote.setInviteUser(inviteUser);

        addInvitePromote.setCreateUser(userId);

        addInvitePromote.setUpdateUser(userId);

        addInvitePromote.setCreateTime(TimeUtil.getTime());

        addInvitePromote.setUpdateTime(TimeUtil.getTime());

        addInvitePromote.setJobId(jobId);

        Integer rows = invitePromoteMapper.insert(addInvitePromote);


        return rows;
    }

    @Override
    public InvitePromoteDto getInvitePromote(Integer id) {
        LambdaQueryWrapper<InvitePromote> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(InvitePromote::getId,id);

        InvitePromote invitePromote = invitePromoteMapper.selectOne(queryWrapper);

        InvitePromoteDto invitePromoteDto=new InvitePromoteDto();

        BeanUtils.copyProperties(invitePromote,invitePromoteDto);

        //获取公司详情
        Company companyDetail = companyService.getCompanyDetail(invitePromoteDto.getEncoding());

        invitePromoteDto.setCompany(companyDetail);

        //获取岗位详情
        JobEntity jobById = jobListService.getJobById(invitePromoteDto.getJobId());

        invitePromoteDto.setJob(jobById);

        //获取招聘信息
        JobPosting jobPosting = jobPostingMapper.selectById(invitePromoteDto.getPostId());

        invitePromoteDto.setJobPost(jobPosting);

        //获取题目详情
        JSONArray questionJSONArray=JSONArray.parseArray(invitePromoteDto.getQuestion());

        List<Map<String,Object>> questions=new ArrayList<>();

        for (int i = 0; i < questionJSONArray.size(); i++) {

            Map<String,Object> getQuestion=new HashMap<>();

           Integer getQuestionId=(Integer)questionJSONArray.get(i);

            Question question = questionMapper.selectById(getQuestionId);

            QuestionBank questionBank = questionBankMapper.selectById(question.getBankId());

            getQuestion.put("questionBankName",questionBank.getTypeName());

            getQuestion.put("QuestionDetail",question);

            questions.add(getQuestion);

        }
        invitePromoteDto.setQuestions(questions);

        return invitePromoteDto;

    }
}
