package com.yzdx.AiInterviewer.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yzdx.AiInterviewer.entity.Question;
import com.yzdx.AiInterviewer.entity.QuestionBank;
import com.yzdx.AiInterviewer.entity.User;
import com.yzdx.AiInterviewer.entity.dto.QuestionDto;
import com.yzdx.AiInterviewer.mapper.QuestionBankMapper;
import com.yzdx.AiInterviewer.mapper.QuestionMapper;
import com.yzdx.AiInterviewer.mapper.UserMapper;
import com.yzdx.AiInterviewer.service.QuestionBankService;
import com.yzdx.AiInterviewer.service.QuestionService;
import com.yzdx.AiInterviewer.service.UserService;
import com.yzdx.AiInterviewer.utiles.TimeUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class QuestionServiceImpl extends ServiceImpl<QuestionMapper, Question> implements QuestionService {

    @Autowired
    private QuestionMapper questionMapper;
    @Autowired
    private UserService userService;
    @Autowired
    private QuestionBankService questionBankService;

    @Override
    public List<QuestionDto> getQuestionList(String encoding)
    {
        //根据公司编码寻找题目
        LambdaQueryWrapper<Question> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(Question::getCompanyEncoding,encoding);

       List<Question> questionList= questionMapper.selectList(queryWrapper);

        List<QuestionDto> questionDtoList = questionList.stream().map((item) -> {
            QuestionDto questionDto=new QuestionDto();

            BeanUtils.copyProperties(item,questionDto);

            Integer createUserId = item.getCreateUser();//创建人id
            //根据id查询创建对象名称
            User findCreateUser = userService.getUserById(createUserId);
            if(findCreateUser != null){
                String createUserName = findCreateUser.getUsername();
                questionDto.setCreateUserName(createUserName);
            }
            Integer updateUserId = item.getUpdateUser();
            //根据id查询更新对象名称
            User findUpdateUser = userService.getUserById(updateUserId);
            if(findUpdateUser != null){
                String updateUserName = findUpdateUser.getUsername();
                questionDto.setUpdateUserName(updateUserName);
            }
            Integer typeId = item.getBankId();
            //根据id查询题库名称
            QuestionBank findBank = questionBankService.getBankById(typeId);
            if(findBank != null){
                String typeNameName = findBank.getTypeName();
                questionDto.setTypeName(typeNameName);
            }
            return questionDto;
        }).collect(Collectors.toList());


     return questionDtoList;
    }

    @Override
    public List<QuestionDto> searchQuestionList(String name, String type, String encoding) {
        if(!name.equals("")){
            if(!type.equals("")){
                LambdaQueryWrapper<Question> queryWrapper=new LambdaQueryWrapper<>();
                queryWrapper.like(Question::getTitle,name).eq(Question::getCompanyEncoding,encoding).eq(Question::getBankId,type);
                List<Question> questions = questionMapper.selectList(queryWrapper);
                List<QuestionDto> questionDtoList = questions.stream().map((item) -> {
                    QuestionDto questionDto=new QuestionDto();

                    BeanUtils.copyProperties(item,questionDto);

                    Integer createUserId = item.getCreateUser();//创建人id
                    //根据id查询创建对象名称
                    User findCreateUser = userService.getUserById(createUserId);
                    if(findCreateUser != null){
                        String createUserName = findCreateUser.getUsername();
                        questionDto.setCreateUserName(createUserName);
                    }
                    Integer updateUserId = item.getUpdateUser();
                    //根据id查询更新对象名称
                    User findUpdateUser = userService.getUserById(updateUserId);
                    if(findUpdateUser != null){
                        String updateUserName = findUpdateUser.getUsername();
                        questionDto.setUpdateUserName(updateUserName);
                    }
                    Integer typeId = item.getBankId();
                    //根据id查询题库名称
                    QuestionBank findBank = questionBankService.getBankById(typeId);
                    if(findBank != null){
                        String typeNameName = findBank.getTypeName();
                        questionDto.setTypeName(typeNameName);
                    }
                    return questionDto;
                }).collect(Collectors.toList());

                return questionDtoList;
            }else {
                LambdaQueryWrapper<Question> queryWrapper=new LambdaQueryWrapper<>();
                queryWrapper.like(Question::getTitle,name).eq(Question::getCompanyEncoding,encoding);
                List<Question> questions = questionMapper.selectList(queryWrapper);
                List<QuestionDto> questionDtoList = questions.stream().map((item) -> {
                    QuestionDto questionDto=new QuestionDto();

                    BeanUtils.copyProperties(item,questionDto);

                    Integer createUserId = item.getCreateUser();//创建人id
                    //根据id查询创建对象名称
                    User findCreateUser = userService.getUserById(createUserId);
                    if(findCreateUser != null){
                        String createUserName = findCreateUser.getUsername();
                        questionDto.setCreateUserName(createUserName);
                    }
                    Integer updateUserId = item.getUpdateUser();
                    //根据id查询更新对象名称
                    User findUpdateUser = userService.getUserById(updateUserId);
                    if(findUpdateUser != null){
                        String updateUserName = findUpdateUser.getUsername();
                        questionDto.setUpdateUserName(updateUserName);
                    }
                    Integer typeId = item.getBankId();
                    //根据id查询题库名称
                    QuestionBank findBank = questionBankService.getBankById(typeId);
                    if(findBank != null){
                        String typeNameName = findBank.getTypeName();
                        questionDto.setTypeName(typeNameName);
                    }
                    return questionDto;
                }).collect(Collectors.toList());

                return questionDtoList;

            }
        }else{
            if(!type.equals("")){
                LambdaQueryWrapper<Question> queryWrapper=new LambdaQueryWrapper<>();
                queryWrapper.like(Question::getCompanyEncoding,encoding).eq(Question::getBankId,type);
                List<Question> questions = questionMapper.selectList(queryWrapper);
                List<QuestionDto> questionDtoList = questions.stream().map((item) -> {
                    QuestionDto questionDto=new QuestionDto();

                    BeanUtils.copyProperties(item,questionDto);

                    Integer createUserId = item.getCreateUser();//创建人id
                    //根据id查询创建对象名称
                    User findCreateUser = userService.getUserById(createUserId);
                    if(findCreateUser != null){
                        String createUserName = findCreateUser.getUsername();
                        questionDto.setCreateUserName(createUserName);
                    }
                    Integer updateUserId = item.getUpdateUser();
                    //根据id查询更新对象名称
                    User findUpdateUser = userService.getUserById(updateUserId);
                    if(findUpdateUser != null){
                        String updateUserName = findUpdateUser.getUsername();
                        questionDto.setUpdateUserName(updateUserName);
                    }
                    Integer typeId = item.getBankId();
                    //根据id查询题库名称
                    QuestionBank findBank = questionBankService.getBankById(typeId);
                    if(findBank != null){
                        String typeNameName = findBank.getTypeName();
                        questionDto.setTypeName(typeNameName);
                    }
                    return questionDto;
                }).collect(Collectors.toList());

                return questionDtoList;

            }else{
                return null;
            }
        }

    }

    @Override
    public Integer addQuestion(String title, Integer bankId, String details, String answer, String encoding, Integer userId) {
        //判断题目标题是否重复
        LambdaQueryWrapper<Question> questionLambdaQueryWrapper=new LambdaQueryWrapper<>();

        questionLambdaQueryWrapper
                .eq(Question::getTitle,title)
                .eq(Question::getBankId,bankId)
                .eq(Question::getCompanyEncoding,encoding);

        Question selectQuestion = questionMapper.selectOne(questionLambdaQueryWrapper);

        if(selectQuestion!=null){
            return -2;
        }
        Question question=new Question();
        question.setTitle(title);
        question.setBankId(bankId);
        question.setDetails(details);
        question.setAnswer(answer);
        question.setCompanyEncoding(encoding);
        question.setCreateUser(userId);
        question.setCreateTime(TimeUtil.getTime());
        question.setUpdateTime(TimeUtil.getTime());
        question.setUpdateUser(userId);

        Integer rows = questionMapper.insert(question);

        return rows;
    }

    @Override
    public Integer updateQuestion(Integer id,String title, Integer bankId, String details, String answer, String encoding, Integer userId) {
        //判断题目标题是否重复
        Question question=new Question();
        question.setId(id);
        question.setTitle(title);
        question.setBankId(bankId);
        question.setDetails(details);
        question.setAnswer(answer);
        question.setCompanyEncoding(encoding);
        question.setUpdateTime(TimeUtil.getTime());
        question.setUpdateUser(userId);
        LambdaQueryWrapper<Question> questionLambdaQueryWrapper=new LambdaQueryWrapper<>();
        questionLambdaQueryWrapper
                .eq(Question::getTitle,question.getTitle())
                .eq(Question::getBankId,question.getBankId())
                .eq(Question::getCompanyEncoding,question.getCompanyEncoding());

        Question selectQuestion = questionMapper.selectOne(questionLambdaQueryWrapper);

        if(selectQuestion!=null){
            return -2;
        }
        Integer rows = questionMapper.updateById(question);

        return rows;

    }

    @Override
    public Integer deleteQuestion(Integer id) {

        LambdaQueryWrapper<Question> queryWrapper=new LambdaQueryWrapper<>();

        queryWrapper.eq(Question::getId,id);

        if(questionMapper.selectOne(queryWrapper)==null){
            return -2;
        }
        Integer rows = questionMapper.delete(queryWrapper);
        return rows;
    }
}
